********************************************************************************
cd "C:\Users\lizhe\Desktop\code\data"
********************************************************************************
* 高水平对外开放下的外资持股与银行流动性创造
********************************************************************************
{
set more off                  
putdocx begin, pagesize(A4) font(Times New Roman,9,black)  margin(all, 0.1) //新建 Word 文档
putdocx paragraph, halign(center) spacing (line, 0.15) //两端对齐
putdocx text ("高水平对外开放下的外资持股与银行流动性创造"), ///
        font(Times New Roman,14,black) bold linebreak 
putdocx save "论文回归模型.docx", replace

* 保留分析中使用的变量
use "data.dta" ,clear
xtset  id year
keep LCCa LCCaEx LCMa LCMaEx  LCCaAsset LCMaAsset LCLia LCOff ///
	T10ForeiCapital Size EquityToAsset DepositToAsset LoanToAsset GDPP ///
	季度 id year ///
	CapitalRatio ///
	Top10LoanRate T10AllCapital InstitShareRatio  ///
	NonintToNet Zm2ACapital LLRToNPL LLRToLoan LPRatio1 LPRatio2 ///
	DigiStratLn SoftwareNums ActiveUsersAPP ActiveUsersAPPR ///
	LT10ForeiCapital LSize LEquityToAsset LDepositToAsset LLoanToAsset LGDPP quarter* indi*
	
save "data.dta", replace
}
********************************************************************************
* 表1  外资持股与银行流动性创造
********************************************************************************
{
use "data.dta" ,clear
xtset  id year

global TT 表1  基准模型：外资持股与银行流动性创造
global YY LCCa LCCaEx LCMa LCMaEx 
global XX L.T10ForeiCapital
global CC L.Size L.EquityToAsset L.DepositToAsset L.LoanToAsset L.GDPP i.季度 i.id, r
RegOut
}
********************************************************************************
* 表2  外资持股对银行流动性创造组成部分的影响
********************************************************************************
{
use "data.dta" ,clear
xtset  id year

global TT 表2  外资持股对银行流动性创造组成部分的影响
global YY LCCaAsset LCMaAsset LCLia LCOff
global CC L.Size L.EquityToAsset L.DepositToAsset L.LoanToAsset L.GDPP i.季度 i.id, r
global XX L.T10ForeiCapital
RegOut
}
********************************************************************************
* 表3-6  中介效应检验
********************************************************************************
{
use "Data.dta" ,clear
xtset id year

global TT 表3-6  中介效应检验


global YY LCCa LCCaEx LCMa LCMaEx
global XX LT10ForeiCapital
global CC LSize LEquityToAsset LDepositToAsset LLoanToAsset LGDPP quarter* indi*
* Here
global xlist  ///
	CapitalRatio ///
	Top10LoanRate T10AllCapital InstitShareRatio  ///
	NonintToNet Zm2ACapital LLRToNPL LLRToLoan LPRatio1 LPRatio2 ///
	DigiStratLn SoftwareNums ActiveUsersAPP ActiveUsersAPPR
	
gen LVar = .
foreach x of global xlist {
    replace  LVar = L.`x'
	global MM	`x' LVar
	Sgmediation 
}
}
********************************************************************************










